#-----------------------------------------------------------------------------
# Posing-to-Dolly
# Jan 15,07
# Copyright (c) 2007 by David G. Drumright (ockham)
# The script will take the current actual position of the Posing cam
# and put the Dolly cam in that place.
#-----------------------------------------------------------------------------

import poser
import math
scene=poser.Scene()

R2D=180.0 / math.pi

Posing=scene.Actor("Posing Camera")

Dolly=scene.Actor("Dolly Camera")

# Locate the object of the Posing cam
scene.DrawAll() # for WV
PG=Posing.Geometry()
Vb=PG.WorldVertex(30) # back vert, by observation of the actual obj
Vf=PG.WorldVertex(22) # front vert
dX=Vf.X()-Vb.X()
dY=Vf.Y()-Vb.Y()
dZ=Vf.Z()-Vb.Z()
cx=(Vf.X()+Vb.X())/2.0
cy=(Vf.Y()+Vb.Y())/2.0
cz=(Vf.Z()+Vb.Z())/2.0
# For the xrot, figure a dHoriz from x and z.
dH=math.hypot(dX,dY)

# Set the dolly's tran at the center of the posing cam object
Dolly.ParameterByCode(poser.kParmCodeXTRAN).SetValue((Vf.X()+Vb.X())/2.0)
Dolly.ParameterByCode(poser.kParmCodeYTRAN).SetValue((Vf.Y()+Vb.Y())/2.0)
Dolly.ParameterByCode(poser.kParmCodeZTRAN).SetValue((Vf.Z()+Vb.Z())/2.0)

# Set its angles by the arctan
yrot=  math.atan2(dX,dZ)
xrot= -math.atan2(dY,dH)
scale=Posing.ParameterByCode(poser.kParmCodeASCALE).Value()
Dolly.ParameterByCode(poser.kParmCodeYROT).SetValue(yrot * R2D)
Dolly.ParameterByCode(poser.kParmCodeXROT).SetValue(xrot * R2D)
Dolly.ParameterByCode(poser.kParmCodeASCALE).SetValue(scale)

#-----------------------------------------------------------------------------
